{****************************************************************************

                     Copyright (c) 1993,94 by Florian Klmpfl

 ****************************************************************************}

unit cobjects;

  interface

    uses
       strings;

    { exportiert einen Stringcontainer, in den mit insert Strings }
    { eingefgt und mit get entnommen werden knnen; wird in      }
    { idlist verwendet                                            }

    type
       pstring = ^string;

       pstringitem = ^tstringitem;

       tstringitem = record
          data : pstring;
          next : pstringitem;
       end;

       pstringcontainer = ^tstringcontainer;

       tstringcontainer = object
          wurzel,last : pstringitem;
          doubles : boolean;
          constructor init;
          destructor done;
          procedure insert(const s : string);
          function get : string;
          procedure clear;
       end;

    procedure stringdispose(var p : pstring);
    function stringdup(const s : string) : pstring;
    function strpnew(const s : string) : pchar;

  implementation

    function strpnew(const s : string) : pchar;

      var
         p : pchar;

      begin
         getmem(p,length(s)+1);
         strpcopy(p,s);
         strpnew:=p;
      end;

    procedure stringdispose(var p : pstring);

      begin
         if p<>nil then
           freemem(p,length(p^)+1);
         p:=nil;
      end;

    function stringdup(const s : string) : pstring;

      var
         p : pstring;

      begin
         getmem(p,length(s)+1);
         p^:=s;
         stringdup:=p;
      end;

    constructor tstringcontainer.init;

      begin
         wurzel:=nil;
         last:=nil;
         doubles:=true;
      end;

    destructor tstringcontainer.done;

      begin
         clear;
      end;

    procedure tstringcontainer.insert(const s : string);

      var
         hp : pstringitem;

      begin
         if not(doubles) then
           begin
              hp:=wurzel;
              while assigned(hp) do
                begin
                   if hp^.data^=s then exit;
                   hp:=hp^.next;
                end;
           end;
         new(hp);
         hp^.next:=nil;
         hp^.data:=stringdup(s);
         if wurzel=nil then wurzel:=hp
           else last^.next:=hp;
         last:=hp;
      end;

    procedure tstringcontainer.clear;

      var
         hp : pstringitem;

      begin
         hp:=wurzel;
         while assigned(hp) do
           begin
              stringdispose(hp^.data);
              wurzel:=hp^.next;
              dispose(hp);
              hp:=wurzel;
           end;
         last:=nil;
         wurzel:=nil;
      end;

    function tstringcontainer.get : string;

      var
         hs : string;
         hp : pstringitem;

      begin
         if wurzel=nil then hs:=''
           else
           begin
              hs:=wurzel^.data^;
              hp:=wurzel;
              wurzel:=wurzel^.next;
              stringdispose(hp^.data);
              dispose(hp);
           end;
         get:=hs;
      end;

end.
